// 001 u_c_global_helper
// 26 feb 2006

(*$r+*)

unit u_asp_bdp_helpers;
  interface
    uses
         system.Data
        , Borland.Data.Provider
        , Borland.Data.Common
        ;

    function f_c_add_input_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size: Integer;
        p_value: System.Object): BdpParameter;
    function f_c_add_output_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size, p_max_precision: Integer): BdpParameter;

    procedure open_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);
    procedure close_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);
    // -- no thread assumptions
    var g_open_bdp_connection_count: Integer= 0;

    function f_bdp_type_name(p_bdp_type: BdpType): System.String;
    function f_bdp_datareader_display(p_c_bdp_datareader: BdpDataReader): String;

  implementation
    uses u_c_asp_net_log
        // , u_types_constants
         ;

    function f_bdp_type_name(p_bdp_type: BdpType): System.String;
      begin
        Result:= Enum.GetName(TypeOf(BdpType), p_bdp_type);
      end; // f_bdp_type_name

      function f_c_add_input_parameter(p_c_bdp_command: BdpCommand;
          p_name: String; p_type, p_subtype: BdpType; p_size: Integer;
          p_value: System.Object): BdpParameter;
        begin
          Result:= BdpParameter.Create(p_name, p_type, p_size);
          Result.Direction:= ParameterDirection.Input;
          Result.Value:= p_value;

          p_c_bdp_command.Parameters.Add(Result);
        end; // add_input_parameter

    function f_c_add_output_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size, p_max_precision: Integer): BdpParameter;
      begin
        Result:= BdpParameter.Create(p_name, p_type, p_size);
        Result.MaxPrecision:= p_max_precision;
        Result.Direction:= ParameterDirection.Output;

        p_c_bdp_command.Parameters.Add(Result);
      end; // add_output_parameter

    procedure open_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);
      begin
        if p_message<> ''
          then write_to_asp_net_log('open_bdp_con '+ g_open_bdp_connection_count.ToString+ ' '+ p_message);
        p_c_bdp_connection.Open();
        Inc(g_open_bdp_connection_count);
      end; // open_bdp_connection_debug

    procedure close_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);
      begin
        p_c_bdp_connection.Close();
        Dec(g_open_bdp_connection_count);
        if p_message<> ''
          then write_to_asp_net_log('close_bdp_con '+ g_open_bdp_connection_count.ToString+ ' '+ p_message);
      end; // close_bdp_connection_debug

    function f_bdp_datareader_display(p_c_bdp_datareader: BdpDataReader): String;
        // -- receives an open BdpDataReader, display all
      const k_new_line= Chr(13)+ Chr(10);
      var l_row_index: Integer;
          l_column_index: Integer;
          l_row_display: String;
      begin
        Result:= '';

        l_row_index:= 0;
        while p_c_bdp_datareader.Read() do
        begin
          l_row_display:= '';
          for l_column_index:= 0 to p_c_bdp_datareader.FieldCount- 1 do
            l_row_display:= l_row_display+ ' '+ p_c_bdp_datareader.GetValue(l_column_index).ToString;
          Result:= Result+ l_row_index.ToString+ ':'+ l_row_display+ k_new_line;
          Inc(l_row_index);
        end; // while p_c_bdp_datareader
      end; // f_bdp_datareader_display
      
    end.
