// 001 u_c_net_log
// 29 oct 2004

// -- (C) John COLIBRI 2004
// -- documentation: http://www.jcolibri.com

// -- wants to make sure that the log is created, unique
// -- since does not know too well which events are called first

(*$r+*)

unit u_c_asp_net_log;
  interface

    const k_do_log_true= True;
          k_do_log_false= False;

    procedure create_asp_net_log(p_full_file_name: System.String);
    procedure write_to_asp_net_log(p_text: System.String);
    procedure set_log(p_do_log: Boolean);

    // procedure do_write_log(p_file_name, p_text: String);

    var _m_indentation: Integer= 0;

  implementation
    Uses
       system.io
       ;

    type c_log= Class
                  m_full_file_name: System.String;
                  Constructor create_log(p_full_file_name: System.String);
                  procedure write_to_log(p_text: System.String);
                end; // c_log

    var _s_append: Boolean= False;

    // -- c_log

    Constructor c_log.create_log(p_full_file_name: System.String);
      var l_c_stream: System.Io.FileStream;
      begin
        Inherited Create;

        m_full_file_name:= p_full_file_name;

        // -- create an empty file
(*
        l_c_stream:= FileStream.Create(p_full_file_name,
              FileMode.Create, FileAccess.Write);
*)
        if not _s_append
          then begin
              // -- when this is called, always create a new file
              l_c_stream:= FileStream.Create(p_full_file_name,
                    FileMode.Create, FileAccess.Write);
              l_c_stream.Close();
            end
          else begin
              if &File.Exists(p_full_file_name)
                then begin
                    write_to_log('create_append');
      (*
                    l_c_stream:= FileStream.Create(p_full_file_name,
                          FileMode.Open, FileAccess.Write);
                    l_c_stream.Close();
      *)
                  end
                else begin
                    // l_c_stream_writer:= &File.AppendText(p_file_name);
                    l_c_stream:= FileStream.Create(p_full_file_name,
                          FileMode.Create, FileAccess.Write);
                    l_c_stream.Close();
                    write_to_log('create_new');
                  end;
            end;
      end; // create_log

    procedure c_log.write_to_log(p_text: System.String);
      var l_c_stream: System.Io.FileStream;
          l_c_stream_writer: StreamWriter;
          l_date_time: System.DateTime;
          l_date: System.String;
      begin
        l_c_stream:= FileStream.Create(m_full_file_name,
          FileMode.Open, FileAccess.Write);

        l_c_stream_writer:= StreamWriter.Create(l_c_stream);
        l_c_stream_writer.BaseStream.Seek(0, SeekOrigin.End);
        // System.DateTime.Now.ToString('f', l_date);
        l_date_time:= System.DateTime.Now;
        l_date:= System.String.Format(' {0} ', [l_date_time.ToString('g')]);

        // l_c_stream_writer.WriteLine(l_date+ p_text);
        // l_c_stream_writer.WriteLine('riri '+ p_text);
        l_c_stream_writer.WriteLine(l_date+ ' '+ p_text);
        l_c_stream_writer.Close;

        l_c_stream.Close;
      end; // write_to_log

    // -- global

    const k_default_name= 'log.txt';

    var _m_c_log: c_log= Nil;
        // -- can toggle to remove all logging
        _do_log: Boolean= True;
        _m_log_name: System.String= '';

    function f_now: System.String;
      var l_date_time: System.DateTime;
          // l_date: System.String;
      begin
        l_date_time:= System.DateTime.Now;
        Result:= System.String.Format(' {0} ', [l_date_time.ToString('g')]);
      end; // f_now

    function _f_spaces(p_space_count: Integer): System.String;
      var l_index: Integer;
      begin
        Result:= '';
        for l_index:= 1 to p_space_count do
          Result:= Result+ '  ';
      end; // _f_spaces

    procedure create_asp_net_log(p_full_file_name: System.String);
      begin
        if _m_log_name= ''
          then _m_log_name:= p_full_file_name;
        if not _do_log
          then Exit;
        if _m_c_log<> Nil
          then Exit;

        if p_full_file_name= ''
          then p_full_file_name:= k_default_name;
        _m_c_log:= c_log.create_log(p_full_file_name);
      end; // create_asp_net_log

    procedure write_to_asp_net_log(p_text: System.String);
      begin
        if not _do_log
          then Exit;
        if _m_c_log= Nil
          then create_asp_net_log(_m_log_name);

        // -- handle the ">", "<" parts
        // if (p_text<> '') and (p_text[1]= '<')
        // if Pos('<', p_text)> 0
        if Pos('<', p_text.Trim())= 1
          then Dec(_m_indentation);
        p_text:= _f_spaces(_m_indentation)+ p_text; // + _m_indentation.ToString;

        _m_c_log.write_to_log(p_text);

        // if (p_text<> '') and (p_text[1]= '>')
        // if Pos('>', p_text)> 0
        if Pos('>', p_text.Trim())= 1
          then Inc(_m_indentation);
      end; // write_to_asp_net_log

    procedure set_log(p_do_log: Boolean);
      begin
      end; // set_log
(*
    procedure do_write_log(p_file_name, p_text: String);
      var l_c_stream_writer: StreamWriter;
      begin
        if not &File.Exists(p_file_name)
          then begin
              l_c_stream_writer:= &File.CreateText(p_file_name);
            end
          else begin
              l_c_stream_writer:= &File.AppendText(p_file_name);
            end;

        l_c_stream_writer.WriteLine(f_now+ ': '+ p_text);
        l_c_stream_writer.Flush();
        l_c_stream_writer.Close();
      end; // do_write_log
*)
  end.


