// 001 u_c_global_helper
// 26 feb 2006

// -- uses display in a TextBox

(*$r+*)

unit u_c_bdp_forms_helpers;
  interface
    uses
         system.Data
        , Borland.Data.Provider
        , Borland.Data.Common
        ;

    function f_c_add_input_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size: Integer;
        p_value: System.Object): BdpParameter;
    function f_c_add_output_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size, p_max_precision: Integer): BdpParameter;

    procedure open_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);
    procedure close_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);

    function f_bdp_type_name(p_bdp_type: BdpType): System.String;

  implementation
    uses u_c_dot_net_display
         ;

    function f_bdp_type_name(p_bdp_type: BdpType): System.String;
      begin
        Result:= Enum.GetName(TypeOf(BdpType), p_bdp_type);
      end; // f_bdp_type_name

      function f_c_add_input_parameter(p_c_bdp_command: BdpCommand;
          p_name: String; p_type, p_subtype: BdpType; p_size: Integer;
          p_value: System.Object): BdpParameter;
        begin
          Result:= BdpParameter.Create(p_name, p_type, p_size);
          Result.Direction:= ParameterDirection.Input;
          Result.Value:= p_value;

          p_c_bdp_command.Parameters.Add(Result);
        end; // add_input_parameter

    function f_c_add_output_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size, p_max_precision: Integer): BdpParameter;
      begin
        Result:= BdpParameter.Create(p_name, p_type, p_size);
        Result.MaxPrecision:= p_max_precision;
        Result.Direction:= ParameterDirection.Output;

        p_c_bdp_command.Parameters.Add(Result);
      end; // add_output_parameter

    procedure open_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);
      begin
        if p_message<> ''
          then display('open_bdp '+ p_message);
        p_c_bdp_connection.Open();
      end; // open_bdp_connection_debug

    procedure close_bdp_connection_debug(p_c_bdp_connection: BdpConnection; p_message: String);
      begin
        p_c_bdp_connection.Close();
        if p_message<> ''
          then display('close_bdp '+ p_message);
      end; // close_bdp_connection_debug
    end.
