// 001 u_c_global_helper
// 26 feb 2006

// -- no ASP or WinodwForms calls

(*$r+*)

unit u_bdp_helpers;
  interface
    uses
         system.Data
        , Borland.Data.Provider
        , Borland.Data.Common
        ;

    function f_c_add_input_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size: Integer;
        p_value: System.Object): BdpParameter;
    function f_c_add_output_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size, p_max_precision: Integer): BdpParameter;

    procedure open_bdp_connection(p_c_bdp_connection: BdpConnection);
    procedure close_bdp_connection(p_c_bdp_connection: BdpConnection);

    function f_bdp_type_name(p_bdp_type: BdpType): System.String;

    function f_c_datareader(p_c_bdp_connection: BdpConnection; p_select: String): BdpDataReader;
    function f_c_datareader_2(p_c_bdp_connection: BdpConnection; p_select: String;
        var pv_c_bdp_transaction: BdpTransaction): BdpDataReader;

    function f_is_bdp_memo_blob(p_c_bdp_datareader: BdpDataReader; p_field_index: Integer): Boolean;
    function f_bdp_memo_string(p_c_bdp_datareader: BdpDataReader; p_field_index: Integer): String;
    
    function f_bdp_datareader_display(p_c_bdp_datareader: BdpDataReader): String;

  implementation

    function f_bdp_type_name(p_bdp_type: BdpType): System.String;
      begin
        Result:= Enum.GetName(TypeOf(BdpType), p_bdp_type);
      end; // f_bdp_type_name

      function f_c_add_input_parameter(p_c_bdp_command: BdpCommand;
          p_name: String; p_type, p_subtype: BdpType; p_size: Integer;
          p_value: System.Object): BdpParameter;
        begin
          Result:= BdpParameter.Create(p_name, p_type, p_size);
          Result.Direction:= ParameterDirection.Input;
          Result.Value:= p_value;

          p_c_bdp_command.Parameters.Add(Result);
        end; // add_input_parameter

    function f_c_add_output_parameter(p_c_bdp_command: BdpCommand;
        p_name: String; p_type, p_subtype: BdpType; p_size, p_max_precision: Integer): BdpParameter;
      begin
        Result:= BdpParameter.Create(p_name, p_type, p_size);
        Result.MaxPrecision:= p_max_precision;
        Result.Direction:= ParameterDirection.Output;

        p_c_bdp_command.Parameters.Add(Result);
      end; // add_output_parameter

    procedure open_bdp_connection(p_c_bdp_connection: BdpConnection);
      begin
        p_c_bdp_connection.Open();
      end; // open_bdp_connection

    procedure close_bdp_connection(p_c_bdp_connection: BdpConnection);
      begin
        p_c_bdp_connection.Close();
      end; // close_bdp_connection

    function f_c_datareader(p_c_bdp_connection: BdpConnection; p_select: String): BdpDataReader;
      var l_c_bdp_transaction: BdpTransaction;
          l_c_bpd_command: BdpCommand;
      begin
        p_c_bdp_connection.Open;
        l_c_bdp_transaction:= p_c_bdp_connection.BeginTransaction;

        l_c_bpd_command:= BdpCommand.Create(p_select, p_c_bdp_connection, l_c_bdp_transaction);
        try
          Result:= l_c_bpd_command.ExecuteReader(CommandBehavior.CloseConnection);
          // display('ok execute reader');
        except
          on e: exception do
            Raise e; // display('reader_err '+ e.Message);
        end; // try except
      end; // f_c_datareader

    function f_c_datareader_2(p_c_bdp_connection: BdpConnection; p_select: String;
        var pv_c_bdp_transaction: BdpTransaction): BdpDataReader;
      var l_c_bpd_command: BdpCommand;
      begin
        p_c_bdp_connection.Open;
        pv_c_bdp_transaction:= p_c_bdp_connection.BeginTransaction;

        l_c_bpd_command:= BdpCommand.Create(p_select, p_c_bdp_connection, pv_c_bdp_transaction);
        try
          Result:= l_c_bpd_command.ExecuteReader(CommandBehavior.CloseConnection);
          // display('ok execute reader');
        except
          on e: exception do
            Raise e; // display('reader_err '+ e.Message);
        end; // try except
      end; // f_c_datareader_2

    // -- blobs

    function f_is_bdp_memo_blob(p_c_bdp_datareader: BdpDataReader; p_field_index: Integer): Boolean;
      begin
        with p_c_bdp_datareader do
          Result:= (GetDataType(p_field_index)= BdpType.Blob) and (GetDataSubType(p_field_index)= BdpType.stMemo);
      end; // f_is_bdp_memo_blob

    function f_bdp_memo_string(p_c_bdp_datareader: BdpDataReader; p_field_index: Integer): String;
      var l_blob_size: Integer;
          l_read_index: Integer;
          l_read_result: Integer;
          l_display_index: Integer;
          l_char_array: Array of Char;
          l_char: Char;
      begin
        l_blob_size:= p_c_bdp_datareader.GetChars(p_field_index, 0, Nil, 0, 0);

        if l_blob_size > 0
          then begin
              SetLength(l_char_array, l_blob_size);
              l_read_index:= 0;
              // -- the result is always 0
              l_read_result:= p_c_bdp_datareader.GetChars(p_field_index, l_read_index, l_char_array, 0, l_blob_size);

              SetLength(Result, l_blob_size);
              for l_display_index:= 0 to l_blob_size- 1 do //l_read_result- 1 do
              begin
                l_char:= l_char_array[l_display_index];
                Result[1+ l_display_index]:= l_char;
              end;
            end
          else Result:= ''  ;
      end; // f_bdp_memo_string

    function f_bdp_datareader_display(p_c_bdp_datareader: BdpDataReader): String;
        // -- receives an open BdpDataReader, display all
      const k_new_line= Chr(13)+ Chr(10);
      var l_row_index: Integer;
          l_column_index: Integer;
          l_row_display: String;
      begin
        Result:= '';

        l_row_index:= 0;
        while p_c_bdp_datareader.Read() do
        begin
          l_row_display:= '';
          for l_column_index:= 0 to p_c_bdp_datareader.FieldCount- 1 do
            l_row_display:= l_row_display+ ' '+ p_c_bdp_datareader.GetValue(l_column_index).ToString;
          Result:= Result+ l_row_index.ToString+ ':'+ l_row_display+ k_new_line;
          Inc(l_row_index);
        end; // while p_c_bdp_datareader
      end; // f_bdp_datareader_display

    end.
